
def zip_longest(*args, fillvalue=0):
    from itertools import zip_longest
    from collections import deque

    def iterables_to_deques(iterables):
        return [deque(iterable) for iterable in iterables]

    def unfill_deques(deques):
        return [deque[i] for i, deque in enumerate(deques) if i < len(deque)]

    zipped = zip_longest(*iterables_to_deques(args))
    return unfill_deques(zipped)



